(function()
{
		//This file is ODPBookmarks, other files are just APIs
			
			var debugingThisFile = false;//sets debuging on/off for this JavaScript file
			
		//listeners
			this.addListener('browserLoad', function (){ODPBookmarks.ODPBookmarksInit()});
			this.addListener('onLocationChange', function (){ODPBookmarks.updateMenuContent()});
			this.addListener('contextMenuShowing', function (){ODPBookmarks.updateMenuContent()} );

		//shutdown
			this.addShutDown(function(){ ODPBookmarks.removeMenu();});

		//init the extension
		this.ODPBookmarksInit = function ()
		{
			this.dump('ODPBookmarksInit', debugingThisFile);
			//bookmarks manager
			this.bookmarks = this.bookmarksGet();
			//adds the menu
			this.addMenu();
			//init the listeners
			this.initListeners();
		};
		//adds the menu 
		this.addMenu = function()
		{
			this.dump('addMenu', debugingThisFile);

			this.bookmarksMenu().addEventListener('popupshowing', function(event){ODPBookmarks.updateMenu(event)}, false);
			
			this.bookmarksMenu().insertBefore(this.getElement('menuseparator'), this.bookmarksMenu().firstChild);
			this.bookmarksMenu().insertBefore(this.getElement('menuitem'), this.bookmarksMenu().firstChild);
		}
		//remove the menu 
		this.removeMenu = function()
		{
			this.dump('removeMenu', debugingThisFile);
			this.bookmarksMenu().removeEventListener('popupshowing', function(event){ODPBookmarks.updateMenu(event)}, false);
		}
		//disable the menu when this is not a category
		this.updateMenu = function (aEvent)
		{
			if(aEvent.originalTarget == this.bookmarksMenu())
			{
				this.updateMenuContent();
			} 
		};
		this.updateMenuContent = function()
		{
			var aCategory = this.categoryGetFocused();
			
			//this.dump('focused category:'+aCategory);
			
			if(aCategory != '')
			{
				this.getElement('menuitem').setAttribute('label', this.getString('bookmark.category').replace('$CATEGORY', this.categoryTitleLastTwoChilds(aCategory)));
				this.getElement('menuitem').setAttribute('hidden', false);
				this.getElement('menuseparator').setAttribute('hidden', false);
				
				if(this.preferenceGet('bookmark.context.menu'))
				{
					this.getElement('context-menu').setAttribute('label', this.getString('bookmark.category').replace('$CATEGORY', this.categoryTitleLastTwoChilds(aCategory)));
					this.getElement('context-menu').setAttribute('hidden', false);
				}
				else
				{
					this.getElement('context-menu').setAttribute('hidden', true);
				}
			}
			else
			{
				this.getElement('menuitem').setAttribute('hidden', true);
				this.getElement('menuseparator').setAttribute('hidden', true);
				this.getElement('context-menu').setAttribute('hidden', true);
			}
		}
		this.bookmarkCatRecursive = function()
		{
			var aCategory = this.categoryGetFocused();

			if(aCategory != '')
			{
				if(ODPBookmarks.confirm(this.getString('computer.slow')))
				{
					var progress = this.progress('bookmarks.cat');
						progress.reset();
						progress.add();

					var categoryFolder = this.bookmarks.createFolder(this.categoryTitleTopAndLastTwoChilds(aCategory));
	
					this.categoryParser(aCategory, function(){ ODPBookmarks.bookmarkCat(arguments[0],arguments[1]);}, categoryFolder);//variable num of arguments
				}
			}
		}
		this.bookmarkCat = function(aCategoryData, parentFolder)
		{
			var progress = this.progress('bookmarks.cat');
				progress.remove();

			var numItems = 0;
			//open cat
			this.bookmarks.prepareItem(this.categoryGetURLPublic(aCategoryData['category']), this.getString('open.category'), parentFolder, numItems++);
			this.bookmarks.createItem();
			//adding cats
			if(this.preferenceGet('bookmark.subcategories') && aCategoryData['subCategories'].length > 0)
			{
				this.bookmarks.createSeparator(parentFolder, numItems++);
				for(var id in aCategoryData['subCategories'])
				{
					progress.add();
					var newFolder = this.bookmarks.createFolder(this.categoryTitleLastChild(aCategoryData['subCategories'][id]), parentFolder, numItems++);
					this.categoryParser(aCategoryData['subCategories'][id], function(){ ODPBookmarks.bookmarkCat(arguments[0],arguments[1]);}, newFolder);
				}
			}
			//adding @links
			if(this.preferenceGet('bookmark.links') && aCategoryData['links'].length > 0)
			{
				this.bookmarks.createSeparator(parentFolder, numItems++);
				for(var id in aCategoryData['links'])
				{
					this.bookmarks.prepareItem(this.categoryGetURLPublic(aCategoryData['links'][id]['category']),  this.categoryTitleLastChild('@'+aCategoryData['links'][id]['anchor']), parentFolder, numItems++);
				}
				this.bookmarks.createItem();
			}
			//adding content
			if(this.preferenceGet('bookmark.sites') && aCategoryData['content'].length > 0)
			{
				this.bookmarks.createSeparator(parentFolder, numItems++);
				if(aCategoryData['content'].length>30 && numItems > 10 || ( aCategoryData['content'].length > 40  ))
					var sitesFolder =  this.bookmarks.createFolder(this.getString('sites'), parentFolder, numItems++);
				else
					var sitesFolder = parentFolder;

				for(var id in aCategoryData['content'])
				{
					if(aCategoryData['content'][id]['cooled'])
						var title =  '★ '+aCategoryData['content'][id]['title'];
					else
						var title = aCategoryData['content'][id]['title'];

					if(aCategoryData['content'][id]['type'] && aCategoryData['content'][id]['type'] != '')
					{
						title += ' ['+aCategoryData['content'][id]['type']+']';
					}
					this.bookmarks.prepareItem(aCategoryData['content'][id]['URI'], title, sitesFolder, numItems++);
				}
				this.bookmarks.createItem();
			}
			//adding relCats
			if(this.preferenceGet('bookmark.related.categories') && aCategoryData['relatedCategories'].length > 0)
			{
				this.bookmarks.createSeparator(parentFolder, numItems++);
				for(var id in aCategoryData['relatedCategories'])
				{
					this.bookmarks.prepareItem(this.categoryGetURLPublic(aCategoryData['relatedCategories'][id]), this.getString('see.also')+' : '+this.categoryTitleLastTwoChilds(aCategoryData['relatedCategories'][id]), parentFolder, numItems++);
				}
				this.bookmarks.createItem();
			}
			//alternativeLanguages
			if(this.preferenceGet('bookmark.alternative.languages') && aCategoryData['alternativeLanguages'].length > 0)
			{
				this.bookmarks.createSeparator(parentFolder, numItems++);
				var altlangsFolder =  this.bookmarks.createFolder(this.getString('alternative.languages').replace(/\.$/, ''), parentFolder, numItems++);

				for(var id in aCategoryData['alternativeLanguages'])
				{
					this.bookmarks.prepareItem(this.categoryGetURLPublic(aCategoryData['alternativeLanguages'][id]['category']), aCategoryData['alternativeLanguages'][id]['title'], altlangsFolder, numItems++);
				}
				this.bookmarks.createItem();
			}
			//became an editor
			if(aCategoryData['allowedEditorApplication'])
			{
				this.bookmarks.createSeparator(parentFolder, numItems++);
				this.bookmarks.prepareItem(this.categoryGetURLPublicApplication(aCategoryData['category']), this.getString('volunteer.to.edit.this.category').replace(/\.$/, ''), parentFolder, numItems++);
				this.bookmarks.createItem();
			}
			//editor list
			if(aCategoryData['editors'].length > 0)
			{
				this.bookmarks.createSeparator(parentFolder, numItems++);
				
				for(var id in aCategoryData['editors'])
				{
					this.bookmarks.prepareItem(this.editorGetURLPublic(aCategoryData['editors'][id]), aCategoryData['editors'][id], parentFolder, numItems++);
				}
				this.bookmarks.createItem();
			}
		}

	return null;

}).apply(ODPBookmarks);
