(function()
{
	//return the context menu of the content area
	this.contentAreaContextMenu = function ()
	{
		return this.getBrowserElement('contentAreaContextMenu');
	}
	//returns a new element
	this.create = function (elementName)
	{
		return document.createElement(elementName);
	}
	//shortcut for document.getElementById
	this.getBrowserElement = function (anID)
	{
		return document.getElementById(anID);
	}
	//return an element of this extension
	this.getElement = function (anID)
	{
		return this.getBrowserElement('ODPBookmarks-'+anID);
	}
	//return a named element of the content document
	this.getElementNamed = function (aName, aDoc)
	{
	  if(!('getElementsByName' in aDoc))
		return null;
	
	  var anElements = aDoc.getElementsByName(aName);
	  if(anElements.length>0)
		  return anElements[0];
	  else
		  return null;
	}
	//this selects nodes ala "jquery" using querySelectorAll on any HTML string.
  this.select = function(aQuery, anHTML, anURI)
  {
	//resolving relative paths
	//relative paths are not resolved by "parseFragment" when strict XML is false.
	  var linkedAttributes = ['href', 'src'];
	  for(var id in linkedAttributes)
	  {
		if(anHTML.indexOf(linkedAttributes[id]+'="') != -1)
		{
		  anHTML = anHTML.split(linkedAttributes[id]+'="');
		  for(var i=1;i<anHTML.length;i++)
		  {
			if(anHTML[i].indexOf('"') !== 0)
			{
			  anHTML[i] =  anHTML[i].split('"');
			  anHTML[i][0] = this.newURI(anURI).resolve(anHTML[i][0]);
			  anHTML[i] = anHTML[i].join('"');
			}
		  }
		  anHTML = anHTML.join(linkedAttributes[id]+'="');
		}
	  }
	
	//creating fragment
	
	  var html = document.implementation.createDocument('http://www.w3.org/1999/xhtml', "html", null);
	  var body = document.createElementNS('http://www.w3.org/1999/xhtml', "body");
		  html.documentElement.appendChild(body);
	
	//escaping content/converting to dom
	  anHTML = '<base href="'+anURI+'" />'+anHTML;
	  anHTML = this.trim(anHTML.replace(/<!DOCTYPE[^>]+>/gi, '').replace(/<html[^>]+>/gi, '<html>'));

	  body.appendChild(Components.classes["@mozilla.org/feed-unescapehtml;1"]
	  .getService(Components.interfaces.nsIScriptableUnescapeHTML)
	  .parseFragment(anHTML, false, this.newURI(anURI)/*this is skipped, is here because maybe is not skiped on some future*/, body));
 
	//doing query
	
	  var found = html.querySelectorAll(aQuery);
	
	//converting the nodeList to an array
	
	  var elements = [];
	  for(var i = 0;i<found.length;i++)
		elements[elements.length] = found[i];
	return elements;
  }
	//returns the tag name of a node in upper case
	this.tagName = function (aNode)
	{
		if(aNode && aNode.tagName)
		{
			var copy = aNode.tagName;
			return String(copy).toLowerCase();
		}
		else
			return '';
	}

	return null;

}).apply(ODPBookmarks);
