(function()
{
	//parse a category data (category public page) and outputs the result to a function
	
	var debugingThisFile = true;//sets debuging on/off for this JavaScript file

	this.categoryParser = function(aCategory, aFunction)
	{			
		this.queueAdd('category.parser', 
					 			[
									aCategory,
									aFunction,
									arguments[2],arguments[3],arguments[4],arguments[5],
									arguments[6],arguments[7],arguments[8],arguments[9]
								]
					  );
		
		this.categoryParserDownload();
	}
	this.categoryParserDownload = function ()
	{
		//avoids more than MAX threads run at same time
		var threads = this.threads(1);
			if(!threads.canRun())
				return;	

		threads.add();
		//ODPBookmarks.dump('categoryParserDownload');

		var aCallback = this.queueGet('category.parser');
		if(!aCallback)
		{
			threads.remove();
		//	ODPBookmarks.dump('categoryParserDownload:There is no more cats');
			return;
		}
		var aCategory = aCallback[0];
		var anURI = this.categoryGetURLPublic(aCategory);
		var Requester = new XMLHttpRequest();
			Requester.overrideMimeType('text/xml');
			Requester.open("GET", anURI, true);
			
		/*
			Requester.onerror = function ()
			{
				threads.remove();
				ODPBookmarks.queueAdd('category.parser', aCallback);
				ODPBookmarks.categoryParserDownload();
			};
		*/
		
		Requester.onload = function ()
		{
			if(Requester.status != '200')
			{
				if(Requester.status == '403') //proxy error
				{
				   	threads.remove();
					ODPBookmarks.dump('http error :403: while reading: "'+aCategory+'" ', true);
					ODPBookmarks.queueAdd('category.parser', aCallback);
					ODPBookmarks.categoryParserDownload();
				}
				else if(
						Requester.status == '500' || //No such category
						Requester.status == '404' || //category not found
						Requester.status == '401'  	//category moved to private zone ej test
						)
				{
					var data = [];
						data['links'] = [];
						data['subCategories'] = [];
						data['relatedCategories'] = [];
						data['content'] = [];
						data['alternativeLanguages'] = [];
						data['editors'] = [];
						data['category'] = aCategory;
						
						data['allowedEditorApplication'] = false;
						data['isKidsTeens'] = false;
						data['isAdult'] = false;
						data['page'] = String(Requester.responseText);
					
				   	threads.remove();
					
					(function()
					{
							aCallback[1](data, 
								aCallback[2],aCallback[3],aCallback[4],aCallback[5],
								aCallback[6],aCallback[7],aCallback[8],aCallback[9]
							)
					}()
					);

					ODPBookmarks.categoryParserDownload();
				}
				else
				{
					threads.remove();
					ODPBookmarks.dump('http error "'+Requester.status +'" while reading: "'+aCategory+'" ', true);
					ODPBookmarks.categoryParserDownload();
				}
			}
			else if(
					Requester.responseText == -1 ||
					Requester.responseText == null ||
					Requester.responseText == ''
			)
			{
				threads.remove();
				ODPBookmarks.dump('responseText is empty while reading : "'+aCategory+'" ', true);
				ODPBookmarks.categoryParserDownload();
			}
			else
			{
				//ODPBookmarks.dump('saving : "'+aCategory+'"', true);
				
				var data = [];
					data['links'] = [];
					data['subCategories'] = [];
					data['relatedCategories'] = [];
					data['content'] = [];
					data['alternativeLanguages'] = [];
					data['editors'] = [];
					data['category'] = aCategory;
					
					data['allowedEditorApplication'] = false;
					data['isKidsTeens'] = false;
					data['isAdult'] = false;
					data['page'] = String(Requester.responseText);
				
				//is kids and teens?
					
					if(ODPBookmarks.categoryIsKidsAndTeens(aCategory))
						data['isKidsTeens'] = true;

				//is adult?
					
					else if(ODPBookmarks.categoryIsAdult(aCategory))
						data['isAdult'] = true;
						
				//is editors applications allowed?
					
					if(ODPBookmarks.categoryParserIsEditorApplicationAllowed(Requester.responseText))//is editor application allowed?
						data['allowedEditorApplication'] = true;
					
					//ODPBookmarks.dump(data['isKidsTeens'], debugingThisFile, 'isKidsTeens');
					//ODPBookmarks.dump(data['isAdult'], debugingThisFile, 'isAdult');
					//ODPBookmarks.dump(data['allowedEditorApplication'], debugingThisFile, 'allowedEditorApplication');

				//@links

					data['links'] = ODPBookmarks.categoryParserGetCategoryLinks(Requester.responseText, anURI);
					//ODPBookmarks.dump(data['links'], debugingThisFile, '@links');

				//subcategories

					data['subCategories'] = ODPBookmarks.categoryParserGetCategorySubcategories(Requester.responseText, anURI);
					//ODPBookmarks.dump(data['subCategories'], debugingThisFile, 'subcategories');

				//content

					data['content'] = ODPBookmarks.categoryParserGetCategorySites(Requester.responseText, anURI);
					//ODPBookmarks.dump(data['content'], debugingThisFile, 'content');

				//relcats

					data['relatedCategories'] = ODPBookmarks.categoryParserGetCategoryRelcats(Requester.responseText, anURI);
					//ODPBookmarks.dump(data['relatedCategories'], debugingThisFile, 'relatedCategories');

				//alternativeLanguages

					data['alternativeLanguages'] = ODPBookmarks.categoryParserGetCategoryAltlangs(Requester.responseText, anURI);
					//ODPBookmarks.dump(data['alternativeLanguages'], debugingThisFile, 'alternativeLanguages');

				//editors

					data['editors'] = ODPBookmarks.categoryParserGetCategoryEditors(Requester.responseText, anURI);
					//ODPBookmarks.dump(data['editors'], debugingThisFile, 'editors');
					
					//return;
				  
					(function()
					{
							aCallback[1](data, 
								aCallback[2], aCallback[3], aCallback[4], aCallback[5],
								aCallback[6], aCallback[7], aCallback[8], aCallback[9]
							)
					}()
					);

				threads.remove();

				ODPBookmarks.categoryParserDownload();
			}
		};
		
		try{Requester.send(null);}catch(e){}
	}
	//parse a category data (category public page HTML) and returns an array with the altlang categories.
	
	this.categoryParserGetCategoryAltlangs = function(aCategoryDocumentHTML, anURI)
	{
	  //var debugingThisFile = false;//sets debuging on/off for this JavaScript file

	  var categoryAltlangs = [];
	  
	  var elements = this.select('.language li', aCategoryDocumentHTML, anURI);
	  
	  for(var id in elements)
	  {
		var element = this.select('a', elements[id].innerHTML, anURI);
		var altlang = [];
			altlang['title'] = this.stripTags(element[0].innerHTML);
			altlang['category'] = this.categoryGetFromURL(element[0].getAttribute('href'));

			categoryAltlangs[categoryAltlangs.length] = altlang;
	  }
	  return categoryAltlangs;
 
	}
	//parse a category data (category public page HTML) and returns an array with the editors if any
	
	this.categoryParserGetCategoryEditors = function(aCategoryDocumentHTML)
	{

		var hrefs = aCategoryDocumentHTML.split('href="');

		var categoryEditors = [];
		var aEditor = '';

		for(var i=0;i<hrefs.length;i++)
		{
			if((aEditor = this.editorGetFromURL((hrefs[i]+'\n').split('\n')[0])) != '')
			{
				categoryEditors[categoryEditors.length] = aEditor;
			}
		}
		return categoryEditors;

	}
	//parse a category data (category public page HTML) and returns an array with the @links
	
	this.categoryParserGetCategoryLinks = function(aCategoryDocumentHTML, anURI)
	{
		//var debugingThisFile = false;//sets debuging on/off for this JavaScript file
		
		var categoryLinks = [];
		
		var elements = this.select('.dir-1 li', aCategoryDocumentHTML, anURI);
		
		for(var id in elements)
		{
		  if(elements[id].innerHTML.indexOf('>@') != -1)
		  {
			var lk = this.select('a', elements[id].innerHTML, anURI)[0];
			
			var link = [];
				link['category'] = this.categoryGetFromURL(lk.getAttribute('href'))
				link['anchor'] = this.stripTags(lk.innerHTML);
				
			  categoryLinks[categoryLinks.length] = link;
		  }
		  else
		  {
			/*its not a link, its a subcategory*/
		  }
		}
		return categoryLinks;
	}
	//parse a category data (category public page HTML) and returns an array with the related categories.
  
  this.categoryParserGetCategoryRelcats = function(aCategoryDocumentHTML, anURI)
  {
	  //var debugingThisFile = false;//sets debuging on/off for this JavaScript file

	  var categoryRelcats = [];
	  
	  var elements = this.select('fieldset.fieldcap .directory li', aCategoryDocumentHTML, anURI);
	  
	  for(var id in elements)
	  {
		  categoryRelcats[categoryRelcats.length] = this.categoryGetFromURL(this.select('a', elements[id].innerHTML, anURI)[0].getAttribute('href'));
	  }
	  return categoryRelcats;
  }
	//parse a category data (category public page HTML) and returns an array with the category listings. TODO:add media date parsing
	
	this.categoryParserGetCategorySites = function(aCategoryDocumentHTML,  anURI)
	{
		var debugingThisFile = false;//sets debuging on/off for this JavaScript file

		var categorySites = [];
		
		var sites = [];
		
		//find  cooled sites
		  var tmp = this.select('.directory-url li.star', aCategoryDocumentHTML, anURI);
		  for(var id in tmp)
			sites[sites.length] = tmp[id];
		
		//find not cooled sites
		  var tmp = this.select('.directory-url li:not(.star)', aCategoryDocumentHTML, anURI);
		  for(var id in tmp)
			sites[sites.length] = tmp[id];
		
		for(var id in sites)
		{
		  var site = [];
		  var link = this.select('a', sites[id].innerHTML, anURI);
		  if(link.length > 0){link = link[0]}
		  else
			continue;
		  
		  siteURL = this.removeNewLines(this.htmlSpecialCharsDecode(this.string(link.getAttribute('href'))));
		  siteTitle = this.removeNewLines(this.htmlSpecialCharsDecode(this.string(link.innerHTML)));
		  siteDescription = this.removeNewLines(this.htmlSpecialCharsDecode(this.string(sites[id].innerHTML.split('</a>')[1]))).replace(/^-[ ]*/,'');
		  
		  	site['URI'] = siteURL;
			site['title'] = siteTitle;
			site['description'] = siteDescription;
		 
		  categorySites[categorySites.length] = site;
		
		/*
			if(isKids_and_Teens)
				hrefs[i] = hrefs[i].replace(/<\/small>/g, '').replace(/<small>/g, '') .replace(/\] -/g, '] ');
			
			if(this.subStrCount(hrefs[i], '://') == 1 || i == hrefs.length -1)
			{
				
				
				var siteTitle='';
				var siteDescription='';
				var siteType='';
				var siteURL='';
				var siteCooled='';
				
				siteURL = hrefs[i].split('"');
				siteURL = siteURL[0];
				
				if((hrefs == hrefs.length -1 && siteURL.indexOf('://') == -1 ) || siteURL.indexOf('/') == 0 || siteURL.indexOf('<') == 0)
					continue;
				siteTitle   = hrefs[i].split('>');
				if(hrefs[i].indexOf('star.gif') != -1)//Is cooled?
				{
					siteDescription = siteTitle[5].replace(/^[^-]+- +/, '').replace(/<.*$/, '');
					siteTitle = siteTitle[2].split('<');
					siteTitle = siteTitle[0];
					siteCooled = 'Y';
				}
				else
				{
					siteDescription = siteTitle[2].replace(/^[^-]+- +/, '').replace(/<.*$/, '');
					siteTitle = siteTitle[1].split('<');
					siteTitle = siteTitle[0];
					siteCooled = '';
				}
				if(siteDescription.indexOf('[') != -1)
				{
					if(siteDescription.indexOf('[Atom]') != -1)
						siteType = 'Atom';
					else if(siteDescription.indexOf('[PDF]') != -1)
						siteType = 'PDF';
					else if(siteDescription.indexOf('[RSS]') != -1)
						siteType = 'RSS';
					else
						siteType = '';
				}
				else
					siteType = '';
				*/
				/*
				site['type'] = siteType;
				site['cooled'] = siteCooled;
				
			}
				*/
		}
		return categorySites;
	}
	//parse a category data (category public page HTML) and returns an array with all the subcategories

	this.categoryParserGetCategorySubcategories = function(aCategoryDocumentHTML, anURI)
	{
		//var debugingThisFile = false;//sets debuging on/off for this JavaScript file

		var categorySubcategories = [];
		
		var elements = this.select('.dir-1 li', aCategoryDocumentHTML, anURI);
		
		for(var id in elements)
		{
		  if(elements[id].innerHTML.indexOf('>@') != -1){/*its a link*/}
		  else
		  {
			categorySubcategories[categorySubcategories.length] = this.categoryGetFromURL(this.select('a', elements[id].innerHTML, anURI)[0].getAttribute('href'));
		  }
		}
		return categorySubcategories;
	}
	//returns true if user can submit an application for editing the category
	this.categoryParserIsEditorApplicationAllowed = function(aCategoryDocumentHTML)
	{
		if(aCategoryDocumentHTML.indexOf('public/apply?cat=') != -1)//is editor application allowed?
			return true;
		else
			return false;
	}

	return null;

}).apply(ODPBookmarks);
