(function()
{
	//gets the subdomain from an URL
	this.getSubdomainFromURL = function(aURL)
	{
		if(!aURL)
			return '';
		//checks if contains the final /, if not it is added
		if(aURL.indexOf('://') != -1 && this.subStrCount(aURL, '/') == 2)
			aURL = aURL+'/';
		return this.removePort(aURL.replace(/^(.+?):\/+(.+?)\/.*$/, "$2")).toLowerCase();
	}
	//returns a URI from an URL
	this.newURI = function(aURL)
	{
		return this.service('ios').newURI(aURL, null, null);
	}
	//remove the port number from a domain name
	this.removePort = function(aDomain)
	{
		if(!aDomain)
			return '';
		return aDomain.replace(/\:[0-9]*$/, '');//the * is for "local" domains like file:////c:/
	}
	//removes the http://www.domain/ from an url
	this.removeSubdomain = function(aURI)
	{
		if(!aURI)
			return '';

		return aURI.replace(/^(.+?):\/+(.+?)\/(.*)$/, "$3");
	}
	//remove the ww. ww09. www09. ww-09. www-09. www. www09. es-en.www. es.www09. (and probably others) from a domain name
	/*
		http://www-142.ibm.com/software/products/uy/es/category/SWF00
		http://es-es.www.mozilla.org/
	*/
	this.removeWWW = function(aDomain)
	{
		if(!aDomain)
			return '';
		var withoutAZ09WWW = aDomain.replace(/^([a-z]|[0-9]|-)+\.www?-?([0-9]+)?\./i, '');
		if(aDomain != withoutAZ09WWW)
			return withoutAZ09WWW;
		else
			return aDomain.replace(/^www?-?([0-9]+)?\./i, '');
	}

	return null;

}).apply(ODPBookmarks);
